<xsl:stylesheet
  xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
  xmlns:xsltlib="http://jsa.or.jp/xsltlib"
  version="1.0">

<xsl:variable name="xsltlib:index_ent" select="//term"/>
<xsl:variable name="xsltlib:index_ref" select="//title"/>
<xsl:template name="xsltlib:xslt_lib_index">
  <xsl:for-each select="$xsltlib:index_ent">
    <xsl:sort select="."/>
    <xsl:choose>
      <xsl:when test=".=preceding::*[count(.|$xsltlib:index_ent)=count($xsltlib:index_ent)]">
        <xsl:text>, </xsl:text>
      </xsl:when>
      <xsl:otherwise>
        <xsl:if test="not(position()=1)">
          <br/>
        </xsl:if>
        <xsl:value-of select="."/>
        <xsl:text>..........</xsl:text>
      </xsl:otherwise>
    </xsl:choose>
    <xsl:apply-templates
      select="ancestor::*[child::*[count(.|$xsltlib:index_ref)=count($xsltlib:index_ref)]][1]"
      mode="xsltlib:indexref"/>
    <xsl:if test="position()=last()">
      <br/>
    </xsl:if>
  </xsl:for-each>
</xsl:template>
<xsl:template match="*" mode="xsltlib:indexref">
  <xsl:value-of select="*[count(.|$xsltlib:index_ref)=count($xsltlib:index_ref)]"/>
</xsl:template>
</xsl:stylesheet>
